;*******************************************************************************
;				RDA5807M_&_WH1602.asm
;	 FM-   RDA5807M  LCD- WH1602
;  ATMEGA8    .  8 .
; 		  :
;-*-          
;-*-       .
;-*-         
;-*-       .
;-*-           
;-*-      .
;-*-        .
;-*-       .
;-*-       EEPROM.
;-*-       .
;-*-       .
;-*-  "-" .
;
;  :
; PD0 - D7 -    WH1602A
; PD1 - D6 -    WH1602A
; PD2 - D5 -    WH1602A
; PD3 - D4 -    WH1602A
; PD4 - E  -   WH1602A
; PD5 - RS -   WH1602A
; PD7 - .   -
;
; PC0 -    
; PC1 -    
; PC2 -  
; PC3 - 
; PC4 - (SDA) -    I2C
; PC5 - (SCL) -    I2C
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
    #define F_CPU (8000000) ; 
	
  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	
;===============================================================================
	.DSEG				;    SRAM ()
	.ORG 0x060			;   
	decnum:		.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
;=============================================================================
	.ESEG				;    EEPROM
	 Fst_EE:	.BYTE 1 		;   ( )
	 Vol_EE:	.BYTE 1 		; 
;=============================================================================
	.CSEG		;  
	.ORG 0 		; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	reti				; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	reti				; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:		;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B
	;	ldi temp,0b11111111			;
	;	out DDRB,temp   			;      
	;	ldi temp,0b00000000			;
	;	out PORTB,temp   			;   D  
			;  ,  .    
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11111111			;
		out PORTC,temp   			;  
		
			;  D,  .  LCD-
	 	ldi temp,0b11111111			;   D  
		out DDRD,temp				;
		ldi temp,0					;
		out PORTD,temp				;   D  
		
			;  0
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;    T0 
		out TCNT0,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		ldi temp,0b00000001			; .    T0
		out TIMSK,temp				;
		
		sei                         ;  
		
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R20  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;  16  
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
;===================   ==================================
		; LCD 
		rcall lcd_init				; LCD 
		ldi r16,0x0					;     
		rcall LCD_SetAddressDD		;    LCD 
		;   
		LOAD_ADDR Z,Mesg_1*2		;.  Z  . "  FM-    MHz "
		rcall LCD_WriteString		;   
		
		;     
		ldi r16,0x0					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		ldi r16,7					;  
		rcall LCD_WriteData			;   LCD
		 ;   
		ldi r16,2					;  0
		rcall LCD_WriteData			;   LCD
		ldi r16,2					;  0
		rcall LCD_WriteData			;   LCD
;------------------------------------------------------------------------------
		;  RDA5807
		rcall IIC_init				;  I2C
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;   EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		DELAY 20					; 656 
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		DELAY 20					; 656 
		; 
		clr r2						;  
		clr freq					;  
		clr temp3					;  R19
		
;-------------------- ----------------------------------------------
main: 			; 
		in temp,PINC				;  
		andi temp,0b00000111		; 
		cpi temp,7					;   , -
		breq main					;   
		;
		sbrs temp,2					;   , -
		rjmp mn_au					;   
		;   
		mov  temp1,temp				;
		andi temp1,0b00000011		;  
		cpi temp1, 1				;   1, 
		breq mn_1					;   R10=1
		cpi temp1, 2				;   2, 
		breq mn_2					;   R10=2
		tst temp1					;   
		breq mn_3					;  
		rjmp main					;
		
mn_1:	ldi temp1,1					;
		mov R10,temp1				; R10=1
		rjmp main					;
		
mn_2:	ldi temp1,2					;
		mov R10,temp1				; R10=2
		rjmp main					;
		
mn_au:	clr temp					;   , -
		sbr temp,4					; 
		mov r1,temp					;  R1=4
		rjmp mn_4					;
		
mn_3:	mov r1,R10					;   
		
		;   ()
mn_4:	DELAY 1						; 32  
		cp r1,r2					;  
		brne main					;  -  
		tst R2						;   ,-
		breq main					;  
		;  , .  
		mov temp,R2					;
		cpi temp,0x4				;   , -
		brne PC+3					;
		rcall mode_s				;   
		rjmp m_loop					; 
		;  
		tst R8						;   
		brne avto					;    
		;  
		sbrc R10,0					;  , -
		rcall St_Up					;     
		sbrc R10,1					;  , -
		rcall St_Down				;     
		rjmp m_loop					; , -  
		;
avto:	sbrc R10,0					;  , -
		rcall freq_Up				;    
		sbrc R10,1					;  , -
		rcall freq_Down				;    
		
m_loop: clr R10						;
		clr R2						;
		rjmp main					;   
		
		;
;===========================================================================
mode_s:		;   /
		DELAY 20					;
		tst R8						;   
		brne rev					;
		mov R8,R2					;  
		rjmp rev_end				;
rev:	clr R8						;  
		
rev_end:clr temp					; temp    
 		ret
;===========================================================================
freq_Up:	;   "+"   
		inc freq					; 
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
			;  "Autotune"
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg5*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		cbi PORTD,7					;  
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
 		ret
;===========================================================================
freq_Down:		;   "-"   
		dec freq					; 
		
			;  "Autotune"
nastr:	ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg5*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		cbi PORTD,7					;  
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					;
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall type_lev				;  
		rcall Prnt_F				;   
		rcall rekog					; 
		
		clr temp					; temp    
 		ret
;===========================================================================
 St_Up:			;     FLASH
 		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		;  
		inc R9						;  
		mov temp,R9
 		cpi temp,Nst				;    > Nst
 		brlo st_u					;
 		clr R9						;     
 		rjmp st_set					;
 		
;---------------------------------------------------------------------------
St_Down:	;     FLASH
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		;  
 		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl st_u					;   ,  -
 		ldi temp,(Nst-1)			;     
 		mov R9,temp					;
 		;     . 
 st_u:	breq st_set					;  =0,   
 		push R9						;
		adiw Z,18					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Prnt_F				;   
		rcall Prn_Ch				;   
		;   
ch_st:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									 ;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		cbi PORTD,7					;  
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall type_lev				;  
		
		clr temp					; temp    
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:	clr R9						;
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,18					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Mesg_2*2		;  . ". "
		rjmp PC+2					;
		
na_ind:	adiw Z,1					;    
			;    
Prn_Ch:	ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		rcall LCD_WriteString		;    
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli
		LOAD_ADDR Y,Fst_EE			;.  Y . .. 
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		sei
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		in r25,SREG					;  . SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		
		out SREG,r25			  	;  
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	
		cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		
		ret

;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		;    LCD
		ldi r16,0x1					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+6					;
		
		; 4-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,6					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+6					;
		
		; 3-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,5					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+6					;
		
		; 2-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+6					;
		
		; 1-  
		ldi r16,3					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		; 0-  
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		
tp_lev:	ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
		tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
Prnt_F:		;    
		ldi r16,0x7					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		;    
		clr r18						;
		ldi r17,HIGH(870)			;  
		ldi temp,LOW(870)			; : 870  
		add temp,freq				;   
		adc r17,r18					;
		;   10- 
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum+3)			;.  X . .   
		clr YH						;
		;  
		ld r16,Y					; .  
		tst r16						;    0,  -
		brne PC+4					;    
		ldi r16,0x20				;
		rcall LCD_WriteData			;  LCD 
		rjmp PC+2
		rcall LCD_WriteHexDigit		;  LCD  
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD  
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD  
		ldI r16,0x2C				;
		rcall LCD_WriteData			;  LCD 
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD   
		
		ret
		
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret
	
;===================================================================================
			;     
 ;Mesg_1: .DB  'R','a','d','i','o','F','M',' ',' ',' ',' ',' ',' ','M','H','z', 0
  Mesg_1: .DB  ' ',' ',' ',' ','F','M','-',' ',' ',' ',' ',' ',' ','M','H','z', 0, 0
  Mesg_2: .DB  'U','n','k','n','o','w',' ','c','h','a','n','n','e','l',' ',' ', 0, 0
  Mesg_3: .DB  ' ',' ',' ',' ','F','M','-',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0, 0
  Messg4: .DB  'M','H','z',0
  Messg5: .DB  ' ',' ',' ',' ','A','u','t','o','T','u','n','e',' ',' ',' ',' ', 0, 0

;====================================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"			;   I2C
	.include "HD44780_driver.asm" 			; LCD
	.include "User_set.asm"					; 
;******************************************************************************

	.EXIT
